#ifndef _GLOOBUSCONFIG_
#define _GLOOBUSCONFIG_

#include <stdlib.h>
#include <gtk/gtk.h>
//#include <glib.h>
#include <string>
#include <string.h>
#include <stdio.h>
//#include <gconf/gconf-client.h>
#include "config.h"

class gloobusConfig;

#include "gloobus-preview-defines.h"

using namespace std;

class gloobusConfig
{
	private:
		bool m_taskbar;
		bool m_ontop;
		bool m_focus;
		bool m_winbar_layout;

		bool		cli_debug;
		gp_action	cli_action;
		char *		cli_target;

	public:
		gloobusConfig					(void);
		~gloobusConfig					(void);

		/* loads and parses configuration file
		 * */
		bool		load_config			(void);

		
		bool		get_gconf_win_layout(void);

		/* Returns if show gloobus-preview in taskbar
		 * */
		bool		get_taskbar			(void);

		/* Returns if show gloobus-preview allways on top
		 * */
		bool		get_ontop			(void);

		/* Returns if close gloobus-preview on lose focus
		 * */
		bool		get_focus			(void);
		
		bool		get_winbar_layout	(void);
		
		/* parses command line arguments
		 * */
		void		parse_args			(int, char **);

		/* returns TRUE if debug mode is requested
		 * */
		bool		get_cli_debug		(void);

		/* returns pointer to filename
		 * */
		char*		get_cli_target		(void);

		/* returns what gloobus-preview must do
		 * */
		gp_action	get_cli_action		(void);
};

#endif
