// ========================== IMAGE INTERFACE ======================== //
// Type: image											   //
// =================================================================== //

#ifndef _IIMAGE_
#define _IIMAGE_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iImage : public interface
{
	protected:
		GdkPixbuf 			* m_pixbuf;
		GdkPixbuf 			* m_pixbufFull;
		GtkWidget 			* m_image;
		GtkWidget 			* m_image_container;



	public:
							iImage				( );
							~iImage				( );
		virtual GdkPixbuf*	get_pixbuf			( ) = 0;

		virtual bool		load				( );
		virtual int 		get_width			( );
		virtual int 		get_height			( );
		virtual void		draw				( GtkContainer * container);
		virtual	void		draw_toolbar		( GtkWidget * container );
		virtual void		end					( );
		virtual bool		can_fullscreen  	( void );
		virtual void		draw_fullscreen 	( GtkContainer * container);
		virtual void		draw_unfullscreen 	( GtkContainer * container);

				void		draw_image			( GtkContainer * container);
				void 		draw_file_info		( GtkContainer * container);
};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iImage* create_t_image();			//CREATE PLUGIN
typedef void destroy_t_image(iImage*);	//DESTROY PLUGIN
	
extern map<string, create_t_image *, less<string> > factory_image;		   //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_image *, less<string> > factoryDestroy_image; //MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	   //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
