// ========================== IMAGE INTERFACE ======================== //
// Type: free											   //
// =================================================================== //

#ifndef _ILIST_
#define _ILIST_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iList : public interface
{
	protected:
		GdkPixbuf		*	m_pixbuf;
		GdkPixbuf		*	m_reflection;
		int					n_items;
		GtkListStore	*	m_store;
		GtkWidget		*	m_scwin;
		GtkWidget		*	m_tree_view;
		guint				loader_id;
		gpointer		*	self_ptr;

	public:
				iList();
				~iList();
		// this virtual functions must be implemented by the plugins:
		virtual GdkPixbuf*		get_pixbuf() = 0;
		virtual GtkListStore*	get_list_store() = 0;
		virtual int 			get_n_columns() = 0;
		virtual string			get_column_title(int i)	= 0;
		virtual int 			get_n_items( void )	 = 0;
		virtual string 			get_item(int i, int j) = 0;
		virtual GdkPixbuf*		get_item_pixbuf(int i, int j) = 0;
		virtual bool			is_column_pixbuf(int i)	= 0;
		virtual bool			has_items( void ) = 0;

		//Virtual Functions implemented from interface
		virtual bool	load				();
		virtual int 	get_width			();
		virtual int 	get_height			();
		virtual	void	draw				( GtkContainer * container );
		virtual	void	draw_toolbar		( GtkWidget * container );	
		virtual void	end					( void );
		virtual bool	can_fullscreen  	( void );						//Returns true if the plugin can do fullscreen
		virtual void	draw_fullscreen 	( GtkContainer * container );
		virtual void	draw_unfullscreen 	( GtkContainer * container );
	
				void		draw_list			( GtkContainer * container ); 
				void 		draw_file_info 		( GtkContainer * container );
				void		draw_icon			( GtkContainer * container );

		static	gboolean	file_loader			(gpointer);
};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iList* create_t_list();									//CREATE PLUGIN
typedef void destroy_t_list(iList*);							   	//DESTROY PLUGIN
	
extern map<string, create_t_list *, less<string> > factory_list;		   //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_list *, less<string> > factoryDestroy_list; //MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	   //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
