// ========================== Music INTERFACE ======================== //
// Type: music				 							   //
// =================================================================== //

#ifndef _IMUSIC_
#define _IMUSIC_



#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include "gloobus-preview-interface-image.h"

using namespace std;

class iMusic : public interface
{
	private:
		//GtkObject 			*m_adjustment;
		GdkPixbuf 				*m_pixbuf;
		GdkPixbuf				*m_reflection;
		GtkWidget 				*m_scale;
		int						m_timeout_id;
		bool 					m_playing;
		GtkWidget				*m_play_pause_button;
		GtkWidget				*m_event_box;

		GtkWidget 				*m_duration_label;
		GtkWidget 				*m_current_time_label;

	public:
								~iMusic			( void );

		//================ INTERFACE FUNCTIONS ================= //
        virtual	void	        draw_toolbar		( GtkWidget * container );
		virtual bool			load				( void );
		virtual void			end					( void );
		virtual int				get_height			( void ); 
		virtual int				get_width			( void );
		virtual bool			can_fullscreen  	( void );						//Returns true if the plugin can do fullscreen
		virtual void			draw_fullscreen 	( GtkContainer * container );
		virtual void			draw_unfullscreen 	( GtkContainer * container );

		// =============== ===================== //
		virtual GdkPixbuf*		get_pixbuf  		( void ) = 0;
		virtual string			get_song_artist		( void ) = 0;
		virtual string			get_song_name		( void ) = 0;
		virtual string			get_song_album  	( void ) = 0;
		virtual string			get_duration		( void ) = 0;	 //Returns the string correctly formed
		virtual string			get_current_time	( void ) = 0;
		
		//================= PLAYER FUNCTIONS =================== //
		virtual void			play 				( void ) = 0;
		virtual void			pause 				( void ) = 0;
		virtual void			stop 				( void ) = 0;
		virtual double			get_position		( void ) = 0;
		virtual void			seek				( gdouble value )   = 0;


				void			draw 				(GtkContainer * container);
				void			draw_cover			(GtkContainer * container);
				void			draw_file_info		(GtkContainer * container);
				void			draw_controls		(GtkContainer * container);
				void			draw_position		( void );
				void			play_pause			( void );

		// Callback
		static void trick	(GtkRange *range, GtkScrollType scroll, gdouble value, gpointer prInstance)						
		{
			iMusic * instance = (iMusic*)prInstance;
			instance->seek( value );					
		};
		static gboolean trick2	(gpointer prInstance)						
		{
			iMusic * instance = (iMusic*)prInstance;
			instance->draw_position( );		
			return true;						//To keep calling the function
		};
		static gboolean play_pause_trick(GtkWidget *widget, GdkEventButton *event,  gpointer prInstance)						
		{
			iMusic * instance = (iMusic*)prInstance;
			instance->play_pause( );		
			return false;						//To keep calling the function
		};

};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iMusic* create_t_music();									   	//CREATE PLUGIN
typedef void destroy_t_music(iMusic*);							   		//DESTROY PLUGIN
//typedef int getVersion_t();									   		//GET PLUGIN_MANAGER VERSION
	
extern map<string, create_t_music *, less<string> > factory_music;		   	 //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_music *, less<string> > factoryDestroy_music;   //MAP WITH NAME AND DESTRUCTOR
//extern vector<plugin_filetype> pluginVector;				          		 //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
