// ========================== Music INTERFACE ======================== //
// Type: movie				 							   //
// =================================================================== //

#ifndef _IMOVIE_
#define _IMOVIE_

#include <map>
#include <string>
#include <vector>

#include <string>



#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iMovie : public interface
{
	private:
		//GtkObject		*m_adjustment;
		GdkPixbuf		*m_pixbuf;
		GdkPixbuf		*m_reflection;
		bool			m_playing;
		GtkWidget		*m_fullscreen_button;
		GtkWidget		*m_play_pause_button;
		GtkWidget		*m_play_pause_button_toolbar;
		GtkWidget		*m_playevent_box;
		GtkWidget		*m_fullevent_box;
		GtkWidget		*m_vbox;

		GtkWidget 		*m_duration_label;
		GtkWidget		*m_current_time_label;

	protected:
	 	GtkWidget		*m_drawable;
	 	GtkWidget		*m_container;
	 	
		GtkWidget 		*m_scale;			//Seek Bar
		int 			m_timeout_id;

	public:
								~iMovie 	( void );
		//Virtual Functions implemented from interface

		virtual bool			load				();
		virtual int 			get_width			();
		virtual int 			get_height			();
		virtual	void			draw				( GtkContainer * container );
        virtual void            draw_toolbar     	( GtkWidget * container);
		virtual void			end					( void );
		virtual bool			can_fullscreen  	( void );						//Returns true if the plugin can do fullscreen
		virtual void			draw_fullscreen 	( GtkContainer * container );
		virtual void			draw_unfullscreen 	( GtkContainer * container );

		// =============== ===================== //
		virtual string			get_duration		( void ) = 0;	 //Returns the string correctly formed
		virtual string			get_current_time	( void ) = 0;
		
		//================= PLAYER FUNCTIONS =================== //
		virtual void			play 				( void ) = 0;
		virtual void			pause 				( void ) = 0;
		virtual void			stop 				( void ) = 0;
		virtual double			get_position		( void ) = 0;
		virtual void			seek				( gdouble value )   = 0;

			void				draw_movie			( GtkContainer * container);
			void				draw_controls		( GtkContainer * container);
			void				hide_controls		( void );
			void				show_controls 		( void );
			void				draw_position		( void );
			void				create_timeout		( void );
			void				play_pause			( void );


		// Callback
		static void trick	(GtkRange *range, GtkScrollType scroll, gdouble value, gpointer prInstance)						
		{
			iMovie * instance = (iMovie*)prInstance;
			instance->seek( value );					
		}
		static gboolean trick2	(gpointer prInstance)						
		{
			iMovie * instance = (iMovie*)prInstance;
			instance->draw_position( );		
			return true;						//To keep calling the function
		}
		static gboolean play_pause_trick(GtkWidget *widget, GdkEventButton *event,  gpointer prInstance)						
		{
			iMovie * instance = (iMovie*)prInstance;
			instance->play_pause( );		
			return false;						//To keep calling the function
		};

		static gboolean fullscreen_trick(GtkWidget *widget, GdkEventButton *event,  gpointer prInstance)						
		{
			//TODO: Call the singleton fullscreen, not the iVideo one...
			iMovie * instance = (iMovie*)prInstance;
			//instance->draw_fullscreen(GTK_CONTAINER(widget));		
			g_debug("Launching Fullscreen Signal");
			instance->set_fullscreen_event();
			//g_signal_emit_by_name(prInstance,"fullscreen-event",0);
			return false;						//To keep calling the function
		};
};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iMovie* create_t_movie();									   	//CREATE PLUGIN
typedef void destroy_t_movie(iMovie*);							   		//DESTROY PLUGIN
//typedef int getVersion_t();									   		//GET PLUGIN_MANAGER VERSION
//	
extern map<string, create_t_movie *, less<string> > factory_movie;		   	 //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_movie *, less<string> > factoryDestroy_movie;   //MAP WITH NAME AND DESTRUCTOR
//extern vector<plugin_filetype> pluginVector;				          		 //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
