#ifndef _IPDF_
#define _IPDF_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iDjvu"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-document.h"

#include <libdjvu/ddjvuapi.h>


class iDjvu : public iDocument
{
	private:
		ddjvu_context_t		*	d_context;
		ddjvu_document_t	*	d_document;
		ddjvu_format_t		*	d_format;
		int						d_page_width;
		int						d_page_height;
		double					d_page_scale;

	public:
							iDjvu			( void );
		virtual				~iDjvu			( void );
		virtual	int			get_n_pages		( void );
		virtual	int			get_page_width	( void );
		virtual	int			get_page_height	( void );
		virtual	GdkPixbuf*	get_page_pixbuf	( int n_page );
		virtual	GtkWidget*	get_page		( int );
		virtual	void		end_plugin		( void );
		virtual	bool		load_doc		( void );

				int			get_page_height_unscaled	( void );
				int			get_page_width_unscaled		( void );

	private:
				void		get_page_size	(gint, int*, int*);
				void		wait_for_message(ddjvu_message_tag_t, GError**);
				void		handle_message	(const ddjvu_message_t*, GError**);
				void		handle_events	(int, GError**);
				void		get_page_scale	( void );
};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iDocument* create() {
    return new iDjvu;
}

extern "C" void destroy(iDocument* p) {
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "image/vnd.djvu","document",1};		// Initial filetype

			factory_document[itself.name] = create;		    // Register the plugin
			factoryDestroy_document[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

