#ifndef _IMP3_
#define _IMP3_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iMpg"		// TODO: Define here the plugin Name


#include <gst/gst.h>
#include <gst/interfaces/xoverlay.h>
#include <gst/video/video.h>

#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <string>
#include <string.h>

#include "../gloobus-preview-interface-video.h"

#define DURATION_IS_VALID(x) (x != 0 && x != (guint64) -1)

class iMpg : public iMovie
{
	private:
		 	GstElement 		*m_pipeline;
		 	GstElement 		*m_sink;
			bool			m_created;
		 	
		 	guint64			m_duration;
			guint64			m_current_time;

            gint            m_videoSize_width;
            gint            m_videoSize_height;

	
    public:
							 iMpg			(void);
							~iMpg			(void);
	virtual void			play 			();
	virtual void			pause 			();
	virtual void 			stop 			();
	virtual double			get_position	( void );
	virtual void			seek			( gdouble value );
	 
	virtual string			get_duration		( void );
	virtual string			get_current_time	( void );

			guint64			get_int_duration	( void );
			string			convert_seconds		( gint64 );

		 	GstElement 		*m_bin;
            bool            QueryVideoSizeFromElement(GstElement* element);
            bool            QueryVideoSizeFromPad(GstPad* pad);

};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iMovie* create() {
    return new iMpg;
}

extern "C" void destroy(iMovie* p) {
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "video/mpeg","movie",1};		// Initial filetype

			factory_movie[itself.name] = create;		    // Register the plugin
			factoryDestroy_movie[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
		    itself.filetype = "video/x-msvideo";			// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			
			itself.filetype = "video/ogg";			// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
							
			itself.filetype = "video/x-theora+ogg";			// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			
			itself.filetype = "video/x-ms-wmv";			// Add another extension supported
			pluginVector.push_back(itself);	
			
			itself.filetype = "video/3gpp";			// Add another extension supported
			pluginVector.push_back(itself);		
			
			itself.filetype = "video/mp4";			// Add another extension supported
			pluginVector.push_back(itself);		
			
			itself.filetype = "video/x-flv";			// Add another extension supported
			pluginVector.push_back(itself);		
			
			itself.filetype = "video/x-matroska";
			pluginVector.push_back(itself);	

			itself.filetype = "video/quicktime";
			pluginVector.push_back(itself);

			//pluginVector.push_back((plugin_filetype){PLUGIN_NAME, "audio/x-mod","movie",1});
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

