#ifndef _IPDF_
#define _IPDF_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPdf"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-document.h"

#include <poppler.h>

#define GP_IDOC_MAX_SIZE 102400


class iPdf : public iDocument
{
		PopplerDocument		*	m_document;
		PopplerPage			*	m_page;
		double					m_scale;

	public:
							iPdf						( void );
		virtual				~iPdf						( void );
		virtual	int			get_n_pages					( void );
		virtual	int			get_page_width				( void );
		virtual	int			get_page_height				( void );
		virtual	GdkPixbuf*	get_page_pixbuf				( int n_page );
		virtual	GtkWidget*	get_page					( int );
		virtual	void		end_plugin					( void );
				bool		load_doc					( void );

	private:
				void		get_scale					( void );
				int			get_page_height_unscaled	( void );
				int			get_page_width_unscaled		( void );
				char*		get_pdf_uri					( void );
				string		get_temp_path				( void );
				char*		path_to_uri					( string );
};

// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iDocument* create() {		
    return new iPdf;
}

extern "C" void destroy(iDocument* p) {
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" {
	class proxy {
		public: proxy() {
			factory_document[PLUGIN_NAME] = create;
			factoryDestroy_document[PLUGIN_NAME] = destroy;
			
			plugin_filetype itself = {
				PLUGIN_NAME,
				"application/pdf",
				"document",
				1
			};
			pluginVector.push_back(itself);

			itself.filetype = "application/vnd.oasis.opendocument.text"; //ODT
			pluginVector.push_back(itself);

			itself.filetype = "application/msword"; //DOC
			pluginVector.push_back(itself);

			itself.filetype = "application/rtf"; //RTF
			pluginVector.push_back(itself);

			itself.filetype = "application/vnd.ms-excel"; //RTF
			pluginVector.push_back(itself);

			itself.filetype = "application/vnd.oasis.opendocument.spreadsheet"; //ODS
			pluginVector.push_back(itself);

			itself.filetype = "application/vnd.ms-powerpoint"; //PPT
			pluginVector.push_back(itself);

			itself.filetype = "application/vnd.sun.xml.calc"; //SXC
			pluginVector.push_back(itself);
		}
	};
	proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

