#ifndef _IPHOTO_
#define _IPHOTO_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPhoto"	// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-image.h"
#include <gdk-pixbuf/gdk-pixbuf.h>


class iPhoto : public iImage
{
	public:
	virtual 	GdkPixbuf*		get_pixbuf  ();
};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iImage* create() {		
	g_debug("Creating iPhoto");
    return new iPhoto;
}

extern "C" void destroy(iImage* p) {
	g_debug("Destroying iPhoto");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			//The priority is used to know wich plugin use if there are more than one that can handle the same
			//filetype, 1 is the lower priority
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype_itself = { NAME OF PLUGIN, MIME TYPE IT SUPPORTS, INHERTED CLASS, PRIORITY}

			plugin_filetype itself = { PLUGIN_NAME, "image/jpeg","image",1};		// Initial filetype

			factory_image[itself.name] = create;		    // Register the plugin
			factoryDestroy_image[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads

			GSList * suportedFormats;
			suportedFormats = gdk_pixbuf_get_formats ();

			for ( ; suportedFormats != NULL; suportedFormats = g_slist_next (suportedFormats))
			{
				char** mimes = gdk_pixbuf_format_get_mime_types    ((GdkPixbufFormat*)suportedFormats->data);
				//for(int i=0; mimes[i] != NULL; i++)
				//g_debug("             %s\n",mimes[0]);
				pluginVector.push_back((plugin_filetype){PLUGIN_NAME, mimes[0],"image",1});	
			}

			g_slist_free(suportedFormats);


			pluginVector.push_back((plugin_filetype){PLUGIN_NAME, "image/vnd.adobe.photoshop",	"image",1});
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME, "image/x-xcf",				"image",1});	
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME, "image/x-compressed-xcf",		"image",1});		
		  
			
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

