#ifndef _IPDF_
#define _IPDF_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPs"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-document.h"

#include <libspectre/spectre.h>

class iPs : public iDocument
{
	private:
		SpectreDocument *p_document;
		gint             p_page_width;
		gint             p_page_height;
		gdouble          p_page_scale;

	public:
		iPs ( void );
		virtual ~iPs ( void );
		virtual	int get_n_pages ( void );
		virtual int get_page_width ( void );
		virtual int get_page_height ( void );
		virtual GdkPixbuf* get_page_pixbuf ( int n_page );
		virtual GtkWidget* get_page ( int );
		virtual	void end_plugin ( void );

		int get_page_height_unscaled ( void );
		int get_page_width_unscaled ( void );
		static void ps_free(guchar*, void*);
		bool load_doc ( void );

	private:
		void get_page_size (gint, int*, int*);
		void get_page_scale ( void );
};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iDocument* create() {
    return new iPs;
}

extern "C" void destroy(iDocument* p) {
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			factory_document[PLUGIN_NAME] = create;
			factoryDestroy_document[PLUGIN_NAME] = destroy;

			pluginVector.push_back((plugin_filetype){
				PLUGIN_NAME,
				"application/postscript",
				"document",
				1
			});

			pluginVector.push_back((plugin_filetype){
				PLUGIN_NAME,
				"application/x-bzpostscript",
				"document",
				1
			});

			pluginVector.push_back((plugin_filetype){
				PLUGIN_NAME,
				"application/x-gzpostscript",
				"document",
				1
			});

			pluginVector.push_back((plugin_filetype){
				PLUGIN_NAME,
				"image/x-eps",
				"document",
				1
			});

			pluginVector.push_back((plugin_filetype){
				PLUGIN_NAME,
				"image/x-bzeps",
				"document",
				1
			});

			pluginVector.push_back((plugin_filetype){
				PLUGIN_NAME,
				"image/x-gzeps",
				"document",
				1
			});
		}
	};
	proxy p; // When we open the dll with RTLD_NOW it creates p,
	         //and in consequence, it registers the plugin
}

#endif

