#include "plugin-swfdec.h"


iSwfdec::iSwfdec()
{
	g_debug("Creating iSwfdec");
	m_loaded = false;
}
iSwfdec::~iSwfdec()
{
	g_debug("Destroying iSwfdec");
	gtk_widget_destroy(m_player_widget);
}

// =============================== GET WIDTH ========================== //
int iSwfdec::get_width	( void )
{
	load_swfdec();
	guint w,h;
	swfdec_player_get_default_size(m_player,&w,&h);
	if(w==0) return 600;
	else 	 return w;
}
// =============================== GET HEIGHT ========================== //
int iSwfdec::get_height( void )
{
	load_swfdec();
	guint w,h;
	swfdec_player_get_default_size(m_player,&w,&h);
	if(h==0) return 500;
	else 	 return h;

}

// =============================== LOAD =============================== //
void iSwfdec::load_swfdec(void)
{
	if(!m_loaded)
	{
		g_debug("Loading SWFDEC Player");
		m_player = swfdec_gtk_player_new (NULL);

		//Pass out the URL or File Path
		SwfdecURL* url = 	swfdec_url_new			( g_file_get_uri (m_gfile));
		  					swfdec_player_set_url	( m_player,url);
		m_player_widget	 = 	swfdec_gtk_widget_new 	( m_player);
		m_loaded = true;
	}
}

// ================================ LOAD ============================== //
void iSwfdec::draw_free( GtkContainer * container)
{
	

	load_swfdec();
  
	gtk_fixed_put 				(GTK_FIXED(container), m_player_widget, SHADOW_WIDTH, HEADER_HEIGHT + SHADOW_WIDTH);
	
	gtk_widget_set_size_request	(m_player_widget, get_width(), get_height());
	gtk_widget_show_all 		(m_player_widget);


	//Get notifications
	//g_signal_connect (player, "notify::initialized", G_CALLBACK (print_infos), NULL);
	//g_signal_connect (player, "notify::aborted", G_CALLBACK (playback_aborted), NULL);

	//Play !
	swfdec_gtk_player_set_playing (SWFDEC_GTK_PLAYER (m_player), TRUE);
  

}
