#ifndef _IPLAIN_
#define _IPLAIN_

#define MANAGER_VERSION 1				// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPlain"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-text.h"
#include <gtksourceview/gtksourceview.h>
#include <gtksourceview/gtksourcelanguagemanager.h>

//sudo ln -s /usr/include/gtksourceview-2.0/gtksourceview/ /usr/include/gtksourceview

class iPlain : public iText
{
	public:
		virtual GtkSourceBuffer*	get_textbuf	(void);
};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iText* create() {
    return new iPlain;
}

extern "C" void destroy(iText* p) {
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
//			plugin_filetype itself = { PLUGIN_NAME, "text/plain","text",1};		// Initial filetype

			factory_text[PLUGIN_NAME] = create;		    // Register the plugin
			factoryDestroy_text[PLUGIN_NAME] = destroy;	// Function for destroy this plugin class


			GtkSourceLanguageManager *lm;
			GtkSourceLanguage * lg;


			lm =                        gtk_source_language_manager_get_default ( );
			const gchar * const * ids = gtk_source_language_manager_get_language_ids(lm);


			for(int i=0; ids[i] != NULL; i++)
			{
					gchar **mimes;
					lg =    gtk_source_language_manager_get_language(lm,ids[i]);
					mimes = gtk_source_language_get_mime_types  (lg);

					g_debug("      Language %s\n", gtk_source_language_get_name (lg));

					if(mimes != NULL)
					{
						for(int j=0; mimes[j] != NULL; j++)
						{
							    g_debug("             %s\n",mimes[j]);
							    pluginVector.push_back((plugin_filetype){PLUGIN_NAME, mimes[j],"text",1});        
						}  
					}                                                                                   
			}


			
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME,"text/plain",					"text",1});	
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME,"text/csv",					"text",1});						
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME,"text/x-log",					"text",1});					
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME,"text/x-readme",				"text",1});
			pluginVector.push_back((plugin_filetype){PLUGIN_NAME,"application/x-subrip",		"text",1});											
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

